# Änderungsziel vs. 1: Funktion bei Klick auf "Auswählen" und "Zurück" auslagern
# Todo: "Zurück" auslagern

Function Main
{

#Ändern? Laufwerke sollten möglichst in der GUI initialisert werden
$Laufwerke = LaufwerkeFinden

[System.String]$Pfad = Gui $Laufwerke

Write-Host "Dateityp nach Übergabe: " $Pfad.GetType()
Write-Host "Datei ausgewählt mit dem Verzeichnis " $Pfad
}


Function Gui ($Laufwerke)
{
[void] [System.Reflection.Assembly]::LoadWithPartialName("System.Windows.Forms")
[void] [System.Reflection.Assembly]::LoadWithPartialName("System.Drawing")

# Eigenschaften Fenster
$Fenster = New-Object System.Windows.Forms.Form
$Fenster.Text = "Laufwerke"
$Fenster.Size = New-Object System.Drawing.Size(900,600) #Breite, Höhe
$Fenster.StartPosition = "CenterScreen"
$Fenster.KeyPreview = $true # was macht das?
$Fenster.MaximumSize = $Fenster.Size # legt fest, dass Größe des Fensters nicht verändert werden kann
$Fenster.MinimumSize = $Fenster.Size

# PfadFeld
$PfadFeld = New-Object System.Windows.Forms.TextBox
$PfadFeld.Location = New-Object System.Drawing.Size(10,10)
$PfadFeld.Size = New-Object System.Drawing.Size(860,20)
#$PfadFeld.Text = $Pfad #Bringt nur etwas, wenn $Pfad einen Anfangswert hat, da der Text nicht laufend aktualisiert wird
$PfadFeld.Add_KeyDown({
    # Reaktion bei gedrückter Taste
    if ($_.KeyCode -eq "Enter")
    {
        $Pfad = $PfadFeld.Text
        # Soll zurückgeben: $true => existiert oder ist *.txt-Datei; $false => existiert nicht
        $PfadExistiert = PfadExistiert $Pfad
        Write-Host "Check Pfadtyp: " $PfadExistiert

        if ($PfadExistiert)
        {
            Write-host "Pfad aktualisieren"
            VerzeichnisAuswaehlen "" $Pfad
        }
        else
        {
            Write-Host "Else-Fall"
            # Fehler-Fenster öffnen?
            # Zurück zu Laufwerke
            # In Funktion auslagern
            $Pfad = ""
            $Optionen = LaufwerkeFinden $Pfad
            $PfadFeld.Text = ""
            $Fenster.Text = "Laufwerke"
            $ListeOrdnernamen.Items.Clear()
            foreach ($Option in $Optionen)
            {
                if ($Option.Length -gt 0)
                {
                    $ListeOrdnernamen.Items.Add($Option)
                }
            }
        }
    }
})
$Fenster.Controls.Add($PfadFeld)

# ListeOrdnernamen
$ListeOrdnernamen = New-Object System.Windows.Forms.ListBox
$ListeOrdnernamen.Location = New-Object System.Drawing.Size(10,40)
$ListeOrdnernamen.Size = New-Object System.Drawing.Size(860,20)
$ListeOrdnernamen.Height = 450
foreach ($Laufwerk in $Laufwerke)
{
    $ListeOrdnernamen.Items.Add($Laufwerk)
}
$ListeOrdnernamen.Add_DoubleClick({
    Write-Host "In Liste per Doppelklick ausgewählt"
    
    # Variablen bestimmen zur Übergabe
    $Auswahl = $ListeOrdnernamen.SelectedItem
    # Falls nicht aktiv ein Eintrag gewählt wurde, in den obersten navigieren
    if ($($Auswahl.length -eq 0))
    {
        $Auswahl = $ListeOrdnernamen.Items[0]
    }
    $Pfad = $PfadFeld.Text
    Write-Host "Gewählter Ordner/ Datei: " $Auswahl
    Write-Host "Vorheriger Pfad: " $Pfad

    # Pfad aktualisieren
    VerzeichnisAuswaehlen $Pfad $Auswahl
})
$ListeOrdnernamen.Add_KeyDown({
    # Reaktion bei gedrückter Taste
    # In Funktion auslagern?
    if ($_.KeyCode -eq "Enter")
    {
        Write-Host "Enter gedrückt"
        
        # Variablen bestimmen zur Übergabe
        $Auswahl = $ListeOrdnernamen.SelectedItem
        # Falls nicht aktiv ein Eintrag gewählt wurde, in den obersten navigieren
        if ($($Auswahl.length -eq 0))
        {
            $Auswahl = $ListeOrdnernamen.Items[0]
        }
        $Pfad = $PfadFeld.Text
        Write-Host "Gewählter Ordner/ Datei: " $Auswahl
        Write-Host "Vorheriger Pfad: " $Pfad

        # Pfad aktualisieren
        VerzeichnisAuswaehlen $Pfad $Auswahl
    }
    elseif ($_.KeyCode -eq "Back")
    {
        Write-Host "Back gedrückt"

        Write-Host "Pfad ausgabe: " $PfadFeld.Text
        $Pfad = $PfadFeld.Text

        #Pfad aktualisieren
        VerzeichnisZurueck $Pfad
    }
    else
    {
        Write-Host "Gedrückte Taste: " $_.KeyCode
    }
})
$Fenster.Controls.Add($ListeOrdnernamen)

<#
# Beispiel Textfeld
$Textfeld1 = New-Object System.Windows.Forms.Label
$Textfeld1.Location = New-Object System.Drawing.Size(7,500)
$Textfeld1.Size = New-Object System.Drawing.Size(130,15)
$Textfeld1.Text = "Beispiel Text"
$Fenster.Controls.Add($Textfeld1)
#>

# ZurückButton
$ZurückButton = New-Object System.Windows.Forms.Button
$ZurückButton.Location = New-Object System.Drawing.Size(10,500)
$ZurückButton.Size = New-Object System.Drawing.Size(100,30)
$ZurückButton.Text = "Zurück"
$ZurückButton.Add_Click({
    Write-Host "Pfad ausgabe: " $PfadFeld.Text
    $Pfad = $PfadFeld.Text

    #Pfad aktualisieren
    VerzeichnisZurueck $Pfad
})
$ZurückButton.Add_KeyDown({
    # In Funktion auslagern?
    # Reaktion bei gedrückter Taste
    if ($_.KeyCode -eq "Back")
    {
        Write-Host "Back gedrückt"
        $Pfad = $PfadFeld.Text

        VerzeichnisZurueck $Pfad
    }

})
$Fenster.Controls.Add($ZurückButton)

# AuswählenButton
$AuswählenButton = New-Object System.Windows.Forms.Button
$AuswählenButton.Location = New-Object System.Drawing.Size(750,500)
$AuswählenButton.Size = New-Object System.Drawing.Size(100,30)
$AuswählenButton.Text = "Auswählen"
$AuswählenButton.Add_Click({
    # Aktion bei Klick oder Enter

    # Variablen bestimmen zur Übergabe
    $Auswahl = $ListeOrdnernamen.SelectedItem
    # Falls nicht aktiv ein Eintrag gewählt wurde, in den obersten navigieren
    if ($($Auswahl.length -eq 0))
    {
        $Auswahl = $ListeOrdnernamen.Items[0]
    }
    $Pfad = $PfadFeld.Text
    Write-Host "Gewählter Ordner/ Datei: " $Auswahl
    Write-Host "Vorheriger Pfad: " $Pfad

    # Pfad aktualisieren
    VerzeichnisAuswaehlen $Pfad $Auswahl
})
$Fenster.Controls.Add($AuswählenButton)

$Fenster.Add_Shown({$Fenster.Activate()})
[void]$Fenster.ShowDialog()
}

Function VerzeichnisAuswaehlen ($Pfad, $Auswahl)
{
if ($Pfad.length -gt 0)
{
    $Pfad = Join-Path -Path $Pfad -ChildPath $Auswahl -Resolve
}
else
{
    $Pfad = $Auswahl
}

#Erkennen, ob *.txt-Datei gewählt wurde -> ggf. Auswahl abgeschlossen
if ($($Auswahl -match ".txt"))
{
    Write-Host ".txt-Datei ausgewählt, Pfad: " $Pfad
    Write-Host "Dateityp: " $Pfad.GetType()
    $Fenster.Dispose()
    NachAuswahl $Pfad
    #return $Pfad
}

# Werte in Form aktualisieren
$PfadFeld.Text = $Pfad
$Fenster.Text = $Auswahl
$ListeOrdnernamen.Items.Clear()
$Optionen = Optionen $Pfad
Write-Host "Mögliche Optionen: " $Optionen
foreach ($Option in $Optionen)
{
    # Write-Host "Option: " $Option
    if ($Option.length -gt 0)
    {
        $ListeOrdnernamen.Items.Add($Option)
    }
}
Write-Host "Neuer Pfad: " $Pfad

return
}

Function NachAuswahl ($Pfad)
{
Write-Host "Auswahl abgeschlossen, ab jetzt .txt-Datei bearbeiten"
Write-Host "Name in Funktion: " $Pfad

#Exit # Wirft Fehler
}

Function VerzeichnisZurueck ($Pfad)
{

if ($Pfad.Length -gt 3)
{
    # Weiter mit Ordnern/Dateien
    Write-Host "Ordner/ Dateien anzeigen"
    $Pfad = Split-Path $Pfad
    Write-Host "Neuer Pfad : " $Pfad
    Write-Host "Pfadwert vor Übergabe: " $Pfad
    $Optionen = Optionen $Pfad
}
elseif ($Pfad.Length -le 3)
{
    # Weiter mit Laufwerken
    Write-Host "Laufwerke anzeigen"
    $Pfad = ""
    $Optionen = LaufwerkeFinden $Pfad
}
else
{
    # Fehler/ Nichts tun?
    # Ermitteln: wann tritt dieser Fall ein?
}

# In Ausgabe schreiben
$PfadFeld.Text = $Pfad
if ($Pfad.Length -gt 3)
{
    $Fenster.Text = $(Split-Path $Pfad -Leaf)
}
else
{
    $Fenster.Text = "Laufwerke"
}
$ListeOrdnernamen.Items.Clear()
foreach ($Option in $Optionen)
{
    # Write-Host "Option: " $Option
    if ($Option.Length -gt 0)
    {
        $ListeOrdnernamen.Items.Add($Option)
    }
}

return
}

Function PfadExistiert ($Pfad)
{
if ($(Test-Path $Pfad -PathType Container) -or $(Test-Path $Pfad -Include "*.txt"))
{
    Write-Host "Bei dem Verzeichnis handelt es sich um eine *.txt-Datei oder ein gültiges Verzeichnis"
    return $true
}
else
{
    Write-Host "Das Verzeichnis existiert nicht oder es wurde keine *.txt-Datei gewählt"
    return $false
}
}

Function LaufwerkeFinden()
{
$Laufwerke = $(Get-PSDrive | where {$_.Free}).Name
$i = 0

foreach($Laufwerk in $Laufwerke)
{
    $Laufwerke[$i] =  $Laufwerk + ":\"
    $i++
}

return $Laufwerke
}

Function TxtDateienFinden($Pfad)
{
$TxtDateien = $(Get-Childitem $Pfad\*.txt)

if ($TxtDateien.Length -gt 0)
{
    return $(Split-Path $TxtDateien -Leaf)
}
else
{
    return
}
}

Function UnterOrdnerFinden($Pfad)
{
#abfangen: keine Ordner vorhanden -> nicht nötig, da keine weitere Verarbeitung
$Ordner = $(Get-Childitem $Pfad -Directory)
return $Ordner
}

Function Optionen($Pfad)
{
# Unterordner und .txt-Dateien finden
# Typzuweisung nötig, da aus unbekanntem Grund sonst Unterordner eines Ordners, der mit "_" beginnt, nicht gefunden werden können
[System.Object[]]$UnterOrdner = UnterOrdnerFinden $Pfad
$TxtDateien = TxtDateienFinden $Pfad

#Gibt aktuell auch Index und Typ (System.IO.DirectoryInfo bzw. System.String) zurück
$Optionen = $UnterOrdner + $TxtDateien

return $Optionen
}


Main